# ÌꎫT̃eLXg̉
# ruby -Ks Kogo.rb SKPKOGO2.DIC
# JgfBNgɎ̃t@Co͂
#   kogo_nn (nn ̓ubNԍ) eubN̉̓eLXgt@C
#   kogocontrols.txt  䕶O̕px

  scrPath = File::dirname($0.gsub(/\\/, '/'))
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ

require 'SJParser'

B_KOGO       = 28  # ÌꎫT            11329
B_MONO       = 29  # ÓTwT    454
B_HITO       = 30  # ÓTwT l   546
B_HON        = 31  # ÓTwT    548
B_MEIKA      = 32  # ̎T              718
B_MEIKU      = 33  # 厫T              372
B_KATUYO1    = 34  # p`                102
B_KATUYO2    = 35  # p`               3674
B_KATUYONOTE = 38  # p`l             64

textBlocks = [B_KOGO, B_MONO, B_HITO, B_HON, B_MEIKA, B_MEIKU]
katuyoBlocks = [B_KATUYO1, B_KATUYO2]
simpleTextBlocks = [B_KATUYONOTE]

def outfname(num)
  sprintf("kogo_%02d", num)
end

def textOut(rec, n, refs, outf)
  outf.printf("---- %05d (%d) ", n, refs.size)
  refs.each do |adr|  # }
    x = sprintf("%02X:%02X%02X%02X", adr[0], adr[1], adr[2], adr[3])
    H[x.slice(0, 3)] += 1
    outf.print '{', x, '}'
  end
  outf.puts ''
  outf.puts rec
end

def katuyoOut(rec, n, refs, outf)
  outf.printf("---- %05d\n", n)
  outf.puts rec
  adr = refs
  if adr != nil
    x = sprintf("%02X:%02X%02X%02X", adr[0], adr[1], adr[2], adr[3])
    H['note:' + x.slice(0, 3)] += 1
    outf.print '{', x, '}', "\n"
  end
end

def noteOut(rec, n, refs, outf)
  outf.printf("---- %05d\n", n)
  outf.puts rec
end

def printBlock(infname, num, klass, func)
  outfname = outfname(num)
  STDERR.puts outfname
  outf = open(outfname, 'w')
  blk = klass::new(infname, num)
  n = 0

  blk.each do |rec, refs|
    STDERR.print n, "\r" if n % 10 == 0
    break if $DEBUG && n >= 10
    Object.send(func, rec, n, refs, outf)
    n += 1
  end

  STDERR.print n, "\n"
  blk.close
  outf.close
end

  infname = ARGV.shift.gsub(/\\/, '/')

  # {
  textBlocks.each do |num|
    printBlock(infname, num, TextBlock, :textOut)
  end

  # p`
  katuyoBlocks.each do |num|
    printBlock(infname, num, KatuyoBlock, :katuyoOut)
  end

  # p`l
  simpleTextBlocks.each do |num|
    printBlock(infname, num, SimpleTextBlock, :noteOut)
  end

  # 䕶AOȂǂo
  if H.size > 0
    open('kogocontrols.txt', 'w') do |f|
      H.sort.each do |k, v|
        f.printf("%-10s %6d\n", k, v)
      end
    end
  end

__END__
