# }`fBÃf[^o
# ruby -Ks Multimedia.rb SKPMDA2.DIC
# JgfBNgɎ̃t@Co͂
#   mm_nn (nn ̓ubNԍ) eubN̉̓eLXgt@C

  scrPath = File::dirname($0.gsub(/\\/, '/'))
  $LOAD_PATH.unshift(scrPath)     # XNvgpX[hpXɒǉ

require 'SuperJ'

B_PIC1     =  0  # ZA*.JPG  摜ubN
B_COLOR    =  1  # ZB*.JPG  FubN
B_PIC2     =  2  # ZC*.JPG  摜ubN
B_PIC3     =  3  # ZD*.JPG  摜ubN
B_PIC4     =  4  # ZE*.JPG  摜ubN
B_PIC5     =  5  # ZF*.JPG  摜ubN
B_PIC6     =  6  # ZG*.JPG  摜ubN
B_PIC7     =  7  # ZH*.JPG  摜ubN
B_PICMAP   =  8  # ZJ*.JPG  }  摜}bvubN
B_MAP      =  9  # ZK*.JPG  n}  摜}bvubN
B_HYAKU    = 10  # ZL*.JPG, SB*.WAV  Sl  SlubN
B_KANSI    = 11  # ZM*.JPG, SC*.WAV, SD*.WAV    ubN
B_HITUZYUN = 12  # MA*.MOV  M  摜ubN

picBlocks = [B_PIC1, B_PIC2, B_PIC3, B_PIC4, B_PIC5, B_PIC6, B_PIC7, B_HITUZYUN]
colorBlocks = [B_COLOR]
picmapBlocks = [B_PICMAP, B_MAP]
hyakuninBlocks = [B_HYAKU]
kansiBlocks = [B_KANSI]

def gaizi(str)
  str.gsub(/#{sprintf('\x%02X..', GAIZI)}/on) {
    code = $&
    sprintf('{%02X:%02X%02X}', code[0], code[1], code[2])
  }
end

def outfname(num)
  sprintf("mm_%02d", num)
end

def picOut(rec, n, out = STDOUT)
  fname = rec['fname']
  title = rec['title']
  adr = rec['ref']
  title = gaizi(title)

  out.puts '%04d: %s  %s' % [n, fname, title]
  adr.each do |x|
    out.printf("%02X:%02X%02X%02X  ", x[0], x[1], x[2], x[3]) 
  end
  out.puts ''
end

def colorOut(rec, n, out = STDOUT)
  fname = rec['fname']
  title = rec['title']
  color = rec['color']
  title = gaizi(title)

  cmyk = 'CMYK=%d,%d,%d,%d' % [color[0], color[1], color[2], color[3]]
  rgb = 'RGB=%02X%02X%02X' % [color[4], color[5], color[6]]
  out.puts '%04d: %s  %-18s %s  %s' % [n, fname, cmyk, rgb, title]
end

def picmapOut(rec, n, out = STDOUT)
  fname = rec['fname']
  title = rec['title']
  text = rec['text']
  adr = rec['ref']
  a = rec['reftitle']
  title = gaizi(title)
  text = gaizi(text)

  out.puts '%04d: %s  %s' % [n, fname, title]
  out.puts text
  adr.each_with_index do |x, i|
    out.printf("%02X:%02X%02X%02X  %s\n", x[0], x[1], x[2], x[3], gaizi(a[i])) 
  end
  out.puts ''
end

def hyakuninOut(rec, n, out = STDOUT)
  title = rec['title']
  gfname = rec['fnamePic']
  sfname = rec['fnameSound']
  title = gaizi(title)

  out.puts '%04d: %s  %s  %s' % [n, gfname, sfname, title]
end

def kansiOut(rec, n, out = STDOUT)
  title = rec['title']
  gfname = rec['fnamePic']
  cfname = rec['fnameCSound']
  jfname = rec['fnameJSound']
  title = gaizi(title)

  out.puts '%04d: %s  %s  %s  %s' % [n, gfname, cfname, jfname, title]
end

def printBlock(infname, num, klass, func)
  outfname = outfname(num)
  STDERR.puts outfname
  outf = open(outfname, 'w')
  blk = klass::new(infname, num)
  n = 0

  blk.each do |rec, refs|
    STDERR.print n, "\r" if n % 10 == 0
    break if $DEBUG && n >= 10
    Object.send(func, rec, n, outf)
    n += 1
  end

  STDERR.print n, "\n"
  blk.close
  outf.close
end

=begin
def printBlock(infname, num, klass, func)
  STDERR.print 'block', num, "\n"
  print '=== ', 'block', num, "\n"

  blk = klass::new(infname, num)
  n = 0
  blk.each do |rec|
    STDERR.print n, "\r" if n % 10 == 0
    break if $DEBUG && n >= 10
    Object.send(func, rec, n)
    n += 1
  end
  blk.close

  STDERR.print n, "\n"
  puts ''
end
=end

  infname = ARGV.shift.gsub(/\\/, '/')

  picBlocks.each do |num|
    printBlock(infname, num, PicBlock, :picOut)
  end

  colorBlocks.each do |num|
    printBlock(infname, num, ColorBlock, :colorOut)
  end

  picmapBlocks.each do |num|
    printBlock(infname, num, PicMapBlock, :picmapOut)
  end

  hyakuninBlocks.each do |num|
    printBlock(infname, num, HyakuninBlock, :hyakuninOut)
  end

  kansiBlocks.each do |num|
    printBlock(infname, num, KansiBlock, :kansiOut)
  end

__END__
