# X[p[{厫Tp[T

require 'SuperJ'
require 'jcode'

H = Hash::new(0)

########## NX

class BlockParser < BlockReader

  def convert(str)
    # '' ̓nCtł͂Ȃ 0xb0 (pJ^Jỉ)
    # Ȃ tr ł̓nCtrŎw肷ƕ͈ (a-zȂ)ɂȂ̂Œ
str.tr("Ӭԭծܦ\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f", "ĂƂȂɂʂ˂̂͂Ђӂւق܂݂ނ߂񂪂Âłǂ΂тԂׂڂς҂Ղ؂\n[BuvAE")
  end

  def parse(f = @f)
    str = ''

    until f.eof?
      ch = f.read(1)
      case ch[0]
      when 0x81..0x9F, 0xE0..0xFA # ..0xFC  1 oCg
        ch2 = f.read(1)
        str << ch << ch2
      when 0xA0..0xDF, 0x06..0x1F
        str << ch
  #    when 0x1F     # convert() œɕϊ
  #      str << "\n"
      when CONTROLS  # ?? ʖ
        ch2 = f.read(1)
        cc, = (ch + ch2).unpack('n')
        case cc
        when REF_START  # Q
          adr = f.read(4)
          x = sprintf("%04X:%02X%02X%02X%02X", cc, adr[0], adr[1], adr[2], adr[3])
          H[x.slice(0, 7)] += 1
          str << '{' << x << '}'
        when END_OF_BLOCK     # ubNI
          x = sprintf("%04X", cc)
          H[x] += 1
          str << '{' << x << '}'
          break
        else
          x = sprintf("%04X", cc)
          H[x] += 1
          str << '{' << x << '}'
        end
      when GAIZI then  # 2 oCgO
        gaizi = f.read(2)
        x = sprintf("%02X:%02X%02X", ch[0], gaizi[0], gaizi[1])
        H[x] += 1
        str << '{' << x << '}'
      when START_OF_RECORD
        f.ungetc(ch[0])
        break
      when 0x00..0x04
        x = sprintf("%02X", ch[0])
        H[x] += 1
        str << '{' << x << '}'
      else
        str << ch
      end
    end

    if str == ''
      return nil
    else
      return convert(str)
    end
  end

end

class TextBlock < BlockParser

  def getrec
    return nil if @f.pos >= @pos + @size

    ch = @f.getc
    return nil if ch != START_OF_RECORD
    x = sprintf("%02X", ch)
    H[x] += 1

    count = @f.getc
    refs = []
    count.times do   # }
      adr = @f.read(4)
      refs.push(adr)
    end

    return parse(@f), refs
  end

end

class SimpleTextBlock < BlockParser

  def getrec
    return nil if @f.pos >= @pos + @size

    ch = @f.getc
    return nil if ch != START_OF_RECORD
    x = sprintf("%02X", ch)
    H[x] += 1

    return parse(@f)
  end

end

class KatuyoBlock < BlockParser

  def getrec
    return nil if @f.pos >= @pos + @size

    len, = @f.read(2).unpack('n')
    return nil if len == END_OF_BLOCK

    text = @f.read(len)
    flag = @f.getc
    if flag == 0x01
      note = @f.read(4)
    else
      note = nil
    end

    fs = StringIO::new(text)
    return parse(fs), note
  end

end

